include "VVram.inc"
; include "Chars.inc"

ext VVram_
ext CellMap_
ext LineRed_

MapWidth equ VVramWidth/2
MapHeight equ VVramHeight/2

Cell_Wall equ 10h
Cell_Item equ 20h
Cell_Mask equ 0f0h

Char_Space equ $20
Char_NormalLine_RightBottom equ $a1
Char_NormalLine_LeftBottom equ $a0
Char_NormalLine_RightTop equ $9f
Char_NormalLine_LeftTop equ $9e
Char_NormalLine_Left equ $88
Char_NormalLine_Right equ $8f
Char_NormalLine_Top equ $96
Char_NormalLine_Bottom equ $9d
Char_BoldLine_RightBottom equ $a3
Char_BoldLine_LeftBottom equ $a2
Char_BoldLine_RightTop equ $a2
Char_BoldLine_LeftTop equ $a3
Char_BoldLine_Left equ $82
Char_BoldLine_Right equ $83
Char_BoldLine_Top equ $90
Char_BoldLine_Bottom equ $91

; ptr<byte> VVramPtr(byte x, byte y);
cseg
VVramPtr_: public VVramPtr_
    push psw | push b
        mov c,a

        mov a,e
        add a ;*2
        add e ;*3
        mov l,a
        mvi h,0
        dad h ;*6
        dad h ;*12
        dad h ;*24
        mvi b,0
        dad b
        lxi b,VVram_
        dad b
    pop b | pop psw
ret


; void MapToVVram();
cseg
BlockChars:
    defb $cd, $cd, $cd, $cd
ItemChars:
    defb $e0, $e1, $e2, $e3
NormalLineChars:
    defb Char_Space, Char_Space, Char_Space, Char_Space ; none
    defb Char_NormalLine_Bottom, Char_Space, Char_NormalLine_Top, Char_Space ; left
    defb Char_Space, Char_NormalLine_Bottom, Char_Space, Char_NormalLine_Top ; right
    defb Char_NormalLine_Bottom, Char_NormalLine_Bottom, Char_NormalLine_Top, Char_NormalLine_Top ; left right
    defb Char_NormalLine_Right, Char_NormalLine_Left, Char_Space, Char_Space ; top
    defb Char_NormalLine_RightBottom, Char_NormalLine_Left, Char_NormalLine_Top, Char_Space ; top left
    defb Char_NormalLine_Right, Char_NormalLine_LeftBottom, Char_Space, Char_NormalLine_Top ; top right
    defb Char_NormalLine_RightBottom, Char_NormalLine_LeftBottom, Char_NormalLine_Top, Char_NormalLine_Top ; top left right
    defb Char_Space, Char_Space, Char_NormalLine_Right, Char_NormalLine_Left ; bottom
    defb Char_NormalLine_Bottom, Char_Space, Char_NormalLine_RightTop, Char_NormalLine_Left ; bottom left
    defb Char_Space, Char_NormalLine_Bottom, Char_NormalLine_Right, Char_NormalLine_LeftTop ; bottom right
    defb Char_NormalLine_Bottom, Char_NormalLine_Bottom, Char_NormalLine_RightTop, Char_NormalLine_LeftTop ; bottom left right
    defb Char_NormalLine_Right, Char_NormalLine_Left, Char_NormalLine_Right, Char_NormalLine_Left ; bottom top
    defb Char_NormalLine_RightBottom, Char_NormalLine_Left, Char_NormalLine_RightTop, Char_NormalLine_Left ; bottom top left
    defb Char_NormalLine_Right, Char_NormalLine_LeftBottom, Char_NormalLine_Right, Char_NormalLine_LeftTop ; bottom top right
    defb Char_NormalLine_RightBottom, Char_NormalLine_LeftBottom, Char_NormalLine_RightTop, Char_NormalLine_LeftTop ; bottom top left right
BoldLineChars:
    defb Char_Space, Char_Space, Char_Space, Char_Space ; none
    defb Char_BoldLine_Bottom, Char_Space, Char_BoldLine_Top, Char_Space ; left
    defb Char_Space, Char_BoldLine_Bottom, Char_Space, Char_BoldLine_Top ; right
    defb Char_BoldLine_Bottom, Char_BoldLine_Bottom, Char_BoldLine_Top, Char_BoldLine_Top ; left right
    defb Char_BoldLine_Right, Char_BoldLine_Left, Char_Space, Char_Space ; top
    defb Char_BoldLine_RightBottom, Char_BoldLine_Left, Char_BoldLine_Top, Char_Space ; top left
    defb Char_BoldLine_Right, Char_BoldLine_LeftBottom, Char_Space, Char_BoldLine_Top ; top right
    defb Char_BoldLine_RightBottom, Char_BoldLine_LeftBottom, Char_BoldLine_Top, Char_BoldLine_Top ; top left right
    defb Char_Space, Char_Space, Char_BoldLine_Right, Char_BoldLine_Left ; bottom
    defb Char_BoldLine_Bottom, Char_Space, Char_BoldLine_RightTop, Char_BoldLine_Left ; bottom left
    defb Char_Space, Char_BoldLine_Bottom, Char_BoldLine_Right, Char_BoldLine_LeftTop ; bottom right
    defb Char_BoldLine_Bottom, Char_BoldLine_Bottom, Char_BoldLine_RightTop, Char_BoldLine_LeftTop ; bottom left right
    defb Char_BoldLine_Right, Char_BoldLine_Left, Char_BoldLine_Right, Char_BoldLine_Left ; bottom top
    defb Char_BoldLine_RightBottom, Char_BoldLine_Left, Char_BoldLine_RightTop, Char_BoldLine_Left ; bottom top left
    defb Char_BoldLine_Right, Char_BoldLine_LeftBottom, Char_BoldLine_Right, Char_BoldLine_LeftTop ; bottom top right
    defb Char_BoldLine_RightBottom, Char_BoldLine_LeftBottom, Char_BoldLine_RightTop, Char_BoldLine_LeftTop ; bottom top left right

MapToVVram_: public MapToVVram_
    push psw | push h | push d | push b
        lxi h,VVram_
        lxi d,CellMap_
        mvi c,MapHeight
        do
            mvi b,MapWidth
            do
                push b
                    ldax d | inx d
                    push d
                        cpi Cell_Wall
                        if z
                            lxi d,BlockChars
                            jmp MapToVVram_store
                        endif
                        cpi Cell_Item
                        if z
                            lxi d,ItemChars
                            jmp MapToVVram_store
                        endif
                        push psw
                            lda LineRed_
                            ora a
                            if z
                                lxi d,NormalLineChars
                            else
                                lxi d,BoldLineChars
                            endif
                        pop psw
                        ani $0f
                        add a
                        add a
                        add e | mov e,a
                        mov a,d | aci 0 | mov d,a
                        MapToVVram_store:
                        push b
                            mvi c,2
                            do
                                mvi b,2
                                do
                                    ldax d | inx d
                                    mov m,a | inx h
                                    dcr b
                                while nz | wend
                                push d
                                    lxi d,VVramWidth-2
                                    dad d
                                pop d
                                dcr c
                            while nz | wend
                        pop b
                        lxi d,2-VVramWidth*2
                        dad d
                    pop d
                pop b
                dcr b
            while nz | wend
            push d
                lxi d,VVramWidth
                dad d
            pop d
            dcr c
        while nz | wend
    pop b | pop d | pop h | pop psw
ret


; ptr<byte> CellMapPtr(byte x, byte y);
cseg
CellMapPtr_: public CellMapPtr_
    push psw | push b
        mov c,a

        mov a,e
        add a ;*2
        add e ;*3
        mov l,a
        mvi h,0
        dad h ;*6
        dad h ;*12
        mvi b,0
        dad b
        lxi b,CellMap_
        dad b
    pop b | pop psw
ret
